<?php

/**
 * @file
 * Rules integration for breadcrumb2.
 *
 * @addtogroup rules
 * @{
 */
 
 /**
 * Implements hook_rules_file_info().
 */
function breadcrumb2_rules_file_info() {
  return array(
    'rules/breadcrumb2.taxonomy',
    'rules/breadcrumb2.eval',
  );
}

/**
 * Implements hook_rules_condition_info().
 */
function breadcrumb2_rules_condition_info() {
  return array(
    'breadcrumb2_breadcrumb_exist' => array(
      'label' => t('Breadcrumb object already exist.'),
      'parameter' => array(
        'path' => array('type' => 'text', 'label' => t('Path'), 'wrapped' => FALSE),
      ),
      'group' => t('Breadcrumb2'),
      'access callback' => 'breadcrumb2_rules_integration_access',
      'base' => 'breadcrumb2_rules_breadcrumb_exist',
    ),
  );
}

 /**
 * Implements hook_rules_action_info().
 */
function breadcrumb2_rules_action_info() {
  $items = array();

  $items['breadcrumb2_append_breadcrumb_trail'] = array(
    'label' => t('Append breadcrumb trail'),
    'group' => t('Breadcrumb2'),
    'parameter' => array(
      'breadcrumb' => array(
        'type' => 'breadcrumb2',
        'label' => t('Breadcrumb'),
        'description' => t('The breadcrumb object who will be appended.'),
        'wrapped' => TRUE,
        'save' => FALSE,
      ),
      'title' => array(
        'type' => 'text',
        'label' => t('title'),
        'wrapped' => FALSE,
      ),
      'url' => array(
        'type' => 'text',
        'label' => t('URL'),
        'wrapped' => FALSE,
      ),
    ),
    'base' => 'breadcrumb2_rules_append_breadcrumb_trail',
    'access callback' => 'breadcrumb2_rules_integration_access',
  );

  $items['breadcrumb2_fetch_lightest_term_from_node'] = array(
    'label' => t('Fetch lightest term from node'),
    'group' => t('Breadcrumb2'),
    'parameter' => array(
      'node' => array(
        'type' => 'node',
        'label' => t('Node'),
        'wrapped' => TRUE,
        'save' => FALSE,
      ),
    ),
    'base' => 'breadcrumb2_rules_fetch_lightest_term_from_node',
    'access callback' => 'breadcrumb2_rules_integration_access',
    'provides' => array(
      'lightest_term' => array(
        'type' => 'taxonomy_term',
        'label' => t('First term'),
      ),
    ),
  );
  
  $items['breadcrumb2_taxonomy_get_parents_all'] = array(
    'label' => t('Taxonomy get parents all'),
    'group' => t('Breadcrumb2'),
    'parameter' => array(
      'taxonomy_term' => array(
        'type' => 'taxonomy_term',
        'label' => t('Taxonomy term'),
        'wrapped' => TRUE,
        'save' => FALSE,
      ),
    ),
    'base' => 'breadcrumb2_rules_taxonomy_get_parents_all',
    'access callback' => 'breadcrumb2_rules_integration_access',
    'provides' => array(
      'parent_terms' => array(
        'type' => 'list<taxonomy_term>',
        'label' => t('Parent terms'),
      ),
    ),
  );    
  return $items;
}

/**
 * Breadcrumb2 rules integration access callback.
 */
function breadcrumb2_rules_integration_access($type, $name) {
  return TRUE;
}
